#ifndef FEMMATRIX_H 
#define FEMMATRIX_H FEMMATRIX_H

#include "FEM_Classes.h" 
#include "complex_hadapt.h"
#include "nodal_dof.h"
#include "Matrix.h"
#include "H.h"
#include <vector>
#include "vector3d.h"
//#include "Helper_Func.h"

extern void xh_2_x( double* , double* , unsigned , dof**  ); 
extern void x_2_xh( double* , double*, unsigned N, dof**  ); 
extern void xh_2_x( dcomp* , dcomp* , unsigned , dof**  ); 
extern void x_2_xh( dcomp* , dcomp*, unsigned N, dof**  ); 
struct FEMMatrix : public CRSMatrix {
  
  mblock<double>** Pre;        // the preconditioner in H-Matrix format
  blcluster *blPre;           // Blck-cl-tree of Pre
  dof** pot_dofARRAY; 
  //dof** ACA_NodesARRAY;
  mblock<double>** A_H;   //Matrix A in H format
  blcluster *blA; 		// Blck-cl-tree of A
  //blcluster *blACA; 		// Blck-cl-tree of A
  
  //extern void x_2_xh( double* x, double* x_h, unsigned N, nodal_dof** Dof ); 
  //extern void xh_2_x( double* xh, double* x, unsigned N, nodal_dof** Dof ); 

  double* xf; 
  double* diag; 
  //double* xh;
  FEMMatrix( unsigned n1, unsigned n2 ) : CRSMatrix( n1, n2 ) {
    xf  =  new double[ n1 ]; 
	//xh = new double[n1];
	diag =  new double[ n1 ]; 
  }
  ~FEMMatrix() { delete [  ] xf;  delete[  ] diag;   }
 
  /*Saad solver test freembls( blPre,Pre ); freembls( blA,A_H ); */ //}
  void precond_apply( double* x ) const {
		x_2_xh( x,xf,n,pot_dofARRAY ); 
		UTHT_vec_solve( blPre, Pre, xf ); 	
		UTH_vec_solve( blPre, Pre, xf ); 
		xh_2_x( xf,x,n,pot_dofARRAY ); 

	// if( i == 0 )
	// {    
	//	// if( excessive_output ) cout << "----NO PRECONDITIONER----\n"; 
	//	 //do nothing --> no precond; 
	// }
	// if( i == 1 ) 
	//{
 //     //if( excessive_output )  cout << "--- JACOBIAN PRECONDITIONER----\n"; 
	// blas::copy( n, x, xf ); 
 //    for( unsigned t = 0; t<n; t++ )
	// {
	//	 xf[ t ] = xf[ t ]*( 1./diag[ t ] ); 
	// }
	 //blas::copy( n, xf, x ); 
	//}//END JACOBIAN PRECOND
	//if( i == 2 ) // HCholesky PRECOND
	//{
		//static double* xh = new double[ n ]; 
		//blas::copy( n, x, y ); 
		//x_2_xh( x,xf,n,pot_dofARRAY ); 
		//UTHT_vec_solve( blPre, Pre, xf ); 	
		//UTH_vec_solve( blPre, Pre, xf ); 
		//xh_2_x( xf,x,n,pot_dofARRAY ); 
		//delete[] xh;
	//}

  }//end precond_apply
}; 

template<class typ> 
struct FEM_Matrix
{
	unsigned m, n;     // dimensions
	typ* A;
	unsigned* jA;
	unsigned* iA;
	mblock<typ>** Pre;        // the preconditioner in H-Matrix format
	blcluster *blPre;           // Blck-cl-tree of Pre
	dof** pot_dofARRAY; 
	mblock<typ>** A_H;   //Matrix A in H format

	mblock<typ>** L;   //Matrix A in H format
	mblock<typ>** U;   //Matrix A in H format

	blcluster *blA; 		// Blck-cl-tree of A

	//  extern void x_2_xh( typ* x, typ* x_h, unsigned N, nodal_dof** Dof ); 
	// extern void xh_2_x( typ* xh, typ* x, unsigned N, nodal_dof** Dof ); 

	typ* xf; 
	typ* diag; 
	FEM_Matrix( unsigned n1, unsigned n2 )
	{
		m=n1;
		n=n2;
		A = NULL; jA = iA = NULL;
		xf  =  new typ[ n1 ]; 
		//xh = new typ[n1];
		diag =  new typ[ n1 ]; 
	}
	~FEM_Matrix() 
	{ 
		//delete [] A; 
		//delete [] jA; 
		//delete [] iA;
		//delete [  ] xf;  
		//delete[  ] diag;   
	}
	void amux(typ d, typ* x, typ *y) const {
		amuxCRS(n, d, x, y, A, jA, iA);
	}
	///*Saad solver test freembls( blPre,Pre ); freembls( blA,A_H ); */ //}
	void precond_apply( typ* x ) const 
	{
		x_2_xh(x,xf,n,pot_dofARRAY);
		HLU_solve(blPre,L,U,xf);
		xh_2_x(xf,x,n,pot_dofARRAY);

		//if( i == 0 )
		//{    
		//	// if( excessive_output ) cout << "----NO PRECONDITIONER----\n"; 
		//	//do nothing --> no precond; 
		//}
		//if( i == 1 ) 
		//{
		//	//if( excessive_output )  cout << "--- JACOBIAN PRECONDITIONER----\n"; 
		//	blas::copy( n, x, xf ); 
		//	for( unsigned t = 0; t<n; t++ )
		//	{
		//		xf[ t ] = xf[ t ]*( 1./diag[ t ] ); 
		//	}
		//	blas::copy( n, xf, x ); 
		//}//END JACOBIAN PRECOND
		//if( i == 2 ) // HCholesky PRECOND
		//{
		//	//static double* xh = new double[ n ]; 
		//	//blas::copy( n, x, y ); 
		//	//x_2_xh( x,xf,n,pot_dofARRAY ); 
		//	//UTHT_vec_solve( blPre, Pre, xf ); 	
		//	//UTH_vec_solve( blPre, Pre, xf ); 
		//	//xh_2_x( xf,x,n,pot_dofARRAY ); 
		//	//delete[] xh;
		//}

	}
};



  //typ* A;
  //unsigned *jA, *iA;

  //CRSMatrix(unsigned n1, unsigned n2) : Matrix<typ>(n1, n2) {
  //  A = NULL; jA = iA = NULL;
  //}
  //~CRSMatrix() { delete [] A; delete [] jA; delete [] iA; }

  //void amux(typ d, typ* x, typ *y) const {
  //  amuxCRS(n, d, x, y, A, jA, iA);
  //}

  //void precond_apply(typ* x) const { }


#endif