#ifndef nodal_dof_H
#define nodal_dof_H

#include <iostream>
#include <vector>

using namespace std;

#include "dof.h"






class nodal_dof : public dof
{

public:
	//! Constructor
	nodal_dof():dof(){};

	//! Destructor
	virtual ~nodal_dof() {};


	virtual unsigned getdim() const { return 3; };

	//! Mapping from AHMED  to HADAPT
	virtual unsigned getHADAPT_PDE_Index() const { return HADAPT_PDE_Index; };
	virtual unsigned getHADAPT_Topological_Index() const { return HADAPT_Topological_Index; };
	virtual double getcenter(const unsigned i) const { assert(i<3); return center[i];};
	virtual double getradius() const{return radius; };	
	virtual double getradius2() const{return radius*radius; };
	virtual void psout(std::ostream&, unsigned beg, unsigned end) const { };

	//! The vector of the HADAPT_Topological_Index in the class topology of the adjacent triangles/tets 
	vector<unsigned> adjacent_elements; 

	//! Index of the unknown in the PDE
	unsigned HADAPT_PDE_Index;

	//! Index of the dof in the topology vector (for example Node[HADAPT_Topological_Index])
	unsigned HADAPT_Topological_Index;

	//!Radius of the dof
	double radius;

	//!Center of gravity of the dof
	double center[3];
};


#endif
