#ifndef H_H
#define H_H

#include "blcluster.h"
//
//double precision real
//
extern unsigned Hmax_rank(blcluster*, mblock<double>**);
extern unsigned HUTmax_rank(blcluster*, mblock<double>**);
extern void HUTmin_dentr(blcluster*, mblock<double>**, double&);
extern unsigned HLTmax_rank(blcluster*, mblock<double>**);
extern mblock<double>** allocmbls(unsigned);
inline mblock<double>** allocmbls(blcluster* bl) { return allocmbls(bl->nleaves()); }

extern void freembls(blcluster*, mblock<double>**);
extern void multa_H_vec(double, blcluster*, mblock<double>**, double*, double*);
extern void multa_H_dense(double, blcluster*, mblock<double>**, unsigned,
			  double*, unsigned, double*, unsigned);
extern void multa_HT_vec(double, blcluster*, mblock<double>**, double*, double*);
extern void multa_HT_dense(double, blcluster*, mblock<double>**, unsigned,
			   double*, unsigned, double*, unsigned);
extern void multa_HSym_vec(double, blcluster*, mblock<double>**, double*, double*);
extern void multa_HSym_dense(double, blcluster*, mblock<double>**, unsigned,
			     double*, unsigned, double*, unsigned);
extern void add_H_lwr(blcluster*, mblock<double>**, double, unsigned, unsigned,
		      double*, unsigned, double*, unsigned);
extern void add_H_dense(blcluster*, mblock<double>**, double*, unsigned,
			double, unsigned);
extern void add_HSym_lwr(blcluster*, mblock<double>**, double, unsigned, unsigned,
			 double*, unsigned, double*, unsigned);
extern void add_HSym_lwr_stab(blcluster*, mblock<double>**, double, unsigned, unsigned,
			      double*, unsigned, double*, unsigned);
extern void add_HSym_dense(blcluster*, mblock<double>**, double*, unsigned,
			   double, unsigned);
extern void multaHH(double, blcluster*, mblock<double>**, blcluster*, mblock<double>**,
		    blcluster*, mblock<double>**, double, unsigned);
extern void multa_H_H_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
			     mblock<double>**, mblock<double>*, double, unsigned);
extern void multaHTH(double, blcluster*, mblock<double>**, blcluster*, mblock<double>**,
		     blcluster*, mblock<double>**, double, unsigned);
extern void multa_HT_H_to_mbl(double, blcluster*, mblock<double>**,
			      blcluster*, mblock<double>**, mblock<double>*, double, unsigned);
extern void multaHTH_to_HSym(double, blcluster*, mblock<double>**, blcluster*,
			     mblock<double>**, blcluster*, mblock<double>**, double, unsigned);
extern void multaHHT(double, blcluster*, mblock<double>**, blcluster*,
		     mblock<double>**, blcluster*, mblock<double>**,
		     double, unsigned);
extern void multa_H_HT_to_mbl(double, blcluster*, mblock<double>**,
			      blcluster*, mblock<double>**, mblock<double>*, double, unsigned);
extern void multaHHT_to_HSym(double, blcluster*, mblock<double>**, blcluster*,
			     mblock<double>**, blcluster*, mblock<double>**,
			     double, unsigned);
extern void multaHSymH(double, blcluster*, mblock<double>**, blcluster*,
		       mblock<double>**, blcluster*, mblock<double>**, double, unsigned);
extern void multaHHSym(double, blcluster*, mblock<double>**, blcluster*,
		       mblock<double>**, blcluster*, mblock<double>**,
		       double, unsigned);
extern void multa_H_lwrT_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				mblock<double>**, mblock<double>*, double, unsigned);
extern void multa_HT_lwr_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				mblock<double>**, mblock<double>*, double, unsigned);
extern void multa_H_denseT_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				  mblock<double>**, mblock<double>*, double, unsigned);
extern void multa_HT_dense_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				  mblock<double>**, mblock<double>*, double, unsigned);
extern void multa_lwr_HT_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				mblock<double>**, mblock<double>*, double, unsigned);
extern void multa_lwrT_H_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				mblock<double>**, mblock<double>*, double, unsigned);
extern void multa_dense_HT_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				  mblock<double>**, mblock<double>*, double, unsigned);
extern void multa_denseT_H_to_mbl(double, blcluster*, mblock<double>**, blcluster*,
				  mblock<double>**, mblock<double>*, double, unsigned);
extern void invertH(blcluster*, mblock<double>**, mblock<double>**, double, unsigned);
extern void invertHSym(blcluster*, mblock<double>**, mblock<double>**, double, unsigned);
extern void initH_0(blcluster*, mblock<double>**);
extern void initLTH_0(blcluster*, mblock<double>**);
extern void initUTH_0(blcluster*, mblock<double>**);
extern void initHSym_0(blcluster*, mblock<double>**);
extern void initH_Id(blcluster*, mblock<double>**);
extern void initHSym_Id(blcluster*, mblock<double>**);
extern unsigned long sizeH(blcluster*, mblock<double>**, char type='H');
extern void convHSymtofull(blcluster**, unsigned, mblock<double>**, double*, unsigned);
extern void psoutputHSym(std::ofstream&, blcluster*, unsigned, mblock<double>**, bool);
extern void psoutputLTH(std::ofstream&, blcluster*, unsigned, mblock<double>**, bool);
extern void psoutputUTH(std::ofstream&, blcluster*, unsigned, mblock<double>**, bool);
extern void psoutputH(std::ofstream&, blcluster*, unsigned, mblock<double>**, bool);
extern void copyH(blcluster*, mblock<double>**, mblock<double>**);
extern double spctrlnrm_sym(unsigned, blcluster*, mblock<double>**, blcluster*,
			    mblock<double>**);
extern double spctrlnrm(unsigned, blcluster*, mblock<double>**, blcluster*, mblock<double>**);

extern void multa_part_vec(double, blcluster**, unsigned, mblock<double>**, double*,
			   double*);
extern void multa_partT_vec(double, blcluster**, unsigned, mblock<double>**, double*,
			    double*);
extern void psoutputH(std::ofstream&, blcluster**, unsigned, unsigned,
		      mblock<double>**, bool);
extern void psoutputHSym(std::ofstream&, blcluster**, unsigned, unsigned,
			 mblock<double>**, bool);
extern void multa_part_vec(double, blcluster**, unsigned,
			   mblock<double>**, double*, double*);
extern void multa_partT_vec(double, blcluster**, unsigned,
			    mblock<double>**, double*, double*);
extern void multa_sympart_vec(double, blcluster**, unsigned, mblock<double>**,
			      double*, double*);
extern void multa_LTH_vec(double, blcluster*, mblock<double>**, double*, double*);
extern void multa_LTHT_vec(double, blcluster*, mblock<double>**, double*, double*);
extern void multa_UTH_vec(double, blcluster*, mblock<double>**, double*, double*);
extern void multa_UTHT_vec(double, blcluster*, mblock<double>**, double*, double*);

extern bool HCholesky(blcluster* const, mblock<double>** const, const double,
		      const unsigned);
extern bool HLU(blcluster*, mblock<double>**, mblock<double>**, mblock<double>**, double, unsigned);

extern void genLUprecond(blcluster*, mblock<double>**, double, unsigned,
			 blcluster*&, mblock<double>**&, mblock<double>**&, bool);
extern void genCholprecond(blcluster*, mblock<double>**, double, unsigned,
			   blcluster*&, mblock<double>**&, bool);

extern void LTH_dense_solve(blcluster*, mblock<double>**, unsigned, double*,
			    unsigned);
extern void LTHT_dense_solve(blcluster*, mblock<double>**, unsigned, double*,
			     unsigned);
extern void UTH_dense_solve(blcluster*, mblock<double>**, unsigned, double*,
			    unsigned);
extern void UTHT_dense_solve(blcluster*, mblock<double>**, unsigned, double*,
			     unsigned);

extern void UTHT_H_solve(blcluster*, mblock<double>**, blcluster*,
			 mblock<double>**, double, unsigned);
extern void LTH_H_solve(blcluster*, mblock<double>**, blcluster*,
			mblock<double>**, mblock<double>**, double, unsigned);
extern void H_UTH_solve(blcluster*, mblock<double>**, blcluster*,
			mblock<double>**, mblock<double>**, double, unsigned);

extern void agglH(blcluster*, mblock<double>**, double, unsigned);

extern void agglHSym_stab(blcluster*, mblock<double>**, double, unsigned);

extern void fill_gaps(blcluster*, mblock<double>**, unsigned, unsigned&);

extern void convCCStoH(unsigned, double*, unsigned*, unsigned*, bool,
		       dof**, double, blcluster*, mblock<double>**&);
extern void convCRStoH(unsigned, double*, unsigned*, unsigned*, bool,
		       dof**, double, blcluster*, mblock<double>**&);
extern void convCCStoHSym(unsigned, double*, unsigned*, unsigned*, bool, dof**,
			  double, blcluster*, mblock<double>**&);
extern void convCRStoHSym(unsigned, double*, unsigned*, unsigned*, bool, dof**,
			  double, blcluster*, mblock<double>**&);

extern void expndHSym(blcluster*, mblock<double>**, blcluster*&, mblock<double>**);


//
//single precision
//

extern unsigned Hmax_rank(blcluster*, mblock<float>**);
extern unsigned HUTmax_rank(blcluster*, mblock<float>**);
extern unsigned HLTmax_rank(blcluster*, mblock<float>**);
extern mblock<float>** sallocmbls(unsigned);
inline mblock<float>** sallocmbls(blcluster* bl) { return sallocmbls(bl->nleaves()); }

extern void freembls(blcluster*, mblock<float>**);
extern void multa_H_vec(float, blcluster*, mblock<float>**, float*, float*);
extern void multa_H_dense(float, blcluster*, mblock<float>**, unsigned,
			  float*, unsigned, float*, unsigned);
extern void multa_HT_vec(float, blcluster*, mblock<float>**, float*, float*);
extern void multa_HT_dense(float, blcluster*, mblock<float>**, unsigned,
			   float*, unsigned, float*, unsigned);
extern void multa_HSym_vec(float, blcluster*, mblock<float>**, float*, float*);
extern void multa_HSym_dense(float, blcluster*, mblock<float>**, unsigned,
			     float*, unsigned, float*, unsigned);
extern void add_H_lwr(blcluster*, mblock<float>**, double, unsigned, unsigned,
		      float*, unsigned, float*, unsigned);
extern void add_H_dense(blcluster*, mblock<float>**, float*, unsigned,
			double, unsigned);
extern void add_HSym_lwr(blcluster*, mblock<float>**, double, unsigned, unsigned,
			 float*, unsigned, float*, unsigned);
extern void add_HSym_lwr_stab(blcluster*, mblock<float>**, double, unsigned, unsigned,
			      float*, unsigned, float*, unsigned);
extern void add_HSym_dense(blcluster*, mblock<float>**, float*, unsigned,
			   double, unsigned);
extern void multaHH(float, blcluster*, mblock<float>**, blcluster*, mblock<float>**,
		    blcluster*, mblock<float>**, double, unsigned);
extern void multa_H_H_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
			     mblock<float>**, mblock<float>*, double, unsigned);
extern void multaHTH(float, blcluster*, mblock<float>**, blcluster*, mblock<float>**,
		     blcluster*, mblock<float>**, double, unsigned);
extern void multa_HT_H_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
			      mblock<float>**, mblock<float>*, double, unsigned);
extern void multaHTH_to_HSym(float, blcluster*, mblock<float>**, blcluster*,
			     mblock<float>**, blcluster*, mblock<float>**, double, unsigned);
extern void multaHHT(float, blcluster*, mblock<float>**, blcluster*,
		     mblock<float>**, blcluster*, mblock<float>**,
		     double, unsigned);
extern void multa_H_HT_to_mbl(float, blcluster*, mblock<float>**,
			      blcluster*, mblock<float>**, mblock<float>*, double, unsigned);
extern void multaHHT_to_HSym(float, blcluster*, mblock<float>**, blcluster*,
			     mblock<float>**, blcluster*, mblock<float>**,
			     double, unsigned);
extern void multaHSymH(float, blcluster*, mblock<float>**, blcluster*,
		       mblock<float>**, blcluster*, mblock<float>**, double, unsigned);
extern void multaHHSym(float, blcluster*, mblock<float>**, blcluster*,
		       mblock<float>**, blcluster*, mblock<float>**,
		       double, unsigned);
extern void multa_H_lwrT_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				mblock<float>**, mblock<float>*, double, unsigned);
extern void multa_HT_lwr_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				mblock<float>**, mblock<float>*, double, unsigned);
extern void multa_H_denseT_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				  mblock<float>**, mblock<float>*, double, unsigned);
extern void multa_HT_dense_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				  mblock<float>**, mblock<float>*, double, unsigned);
extern void multa_lwr_HT_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				mblock<float>**, mblock<float>*, double, unsigned);
extern void multa_lwrT_H_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				mblock<float>**, mblock<float>*, double, unsigned);
extern void multa_dense_HT_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				  mblock<float>**, mblock<float>*, double, unsigned);
extern void multa_denseT_H_to_mbl(float, blcluster*, mblock<float>**, blcluster*,
				  mblock<float>**, mblock<float>*, double, unsigned);
extern void invertH(blcluster*, mblock<float>**, mblock<float>**, double, unsigned);
extern void invertHSym(blcluster*, mblock<float>**, mblock<float>**, double, unsigned);
extern void initH_0(blcluster*, mblock<float>**);
extern void initLTH_0(blcluster*, mblock<float>**);
extern void initUTH_0(blcluster*, mblock<float>**);
extern void initHSym_0(blcluster*, mblock<float>**);
extern void initH_Id(blcluster*, mblock<float>**);
extern void initHSym_Id(blcluster*, mblock<float>**);
extern unsigned long sizeH(blcluster*, mblock<float>**, char type='H');
extern void convHSymtofull(blcluster**, unsigned, mblock<float>**, float*, unsigned);
extern void psoutputHSym(std::ofstream&, blcluster*, unsigned, mblock<float>**, bool);
extern void psoutputLTH(std::ofstream&, blcluster*, unsigned, mblock<float>**, bool);
extern void psoutputUTH(std::ofstream&, blcluster*, unsigned, mblock<float>**, bool);
extern void psoutputH(std::ofstream&, blcluster*, unsigned, mblock<float>**, bool);
extern void copyH(blcluster*, mblock<float>**, mblock<float>**);
extern void copyH(blcluster*, mblock<double>**, mblock<float>**);
extern float spctrlnrm_sym(unsigned, blcluster*, mblock<float>**, blcluster*,
			    mblock<float>**);
extern float spctrlnrm(unsigned, blcluster*, mblock<float>**, blcluster*, mblock<float>**);

extern void multa_part_vec(float, blcluster**, unsigned, mblock<float>**, float*,
			   float*);
extern void multa_partT_vec(float, blcluster**, unsigned, mblock<float>**, float*,
			    float*);
extern void psoutputH(std::ofstream&, blcluster**, unsigned, unsigned,
		      mblock<float>**, bool);
extern void psoutputHSym(std::ofstream&, blcluster**, unsigned, unsigned,
			 mblock<float>**, bool);
extern void multa_part_vec(float, blcluster**, unsigned,
			   mblock<float>**, float*, float*);
extern void multa_partT_vec(float, blcluster**, unsigned,
			    mblock<float>**, float*, float*);
extern void multa_sympart_vec(float, blcluster**, unsigned, mblock<float>**,
			      float*, float*);
extern void multa_LTH_vec(float, blcluster*, mblock<float>**, float*, float*);
extern void multa_LTHT_vec(float, blcluster*, mblock<float>**, float*, float*);
extern void multa_UTH_vec(float, blcluster*, mblock<float>**, float*, float*);
extern void multa_UTHT_vec(float, blcluster*, mblock<float>**, float*, float*);

extern void HCholesky(blcluster* const, mblock<float>**, double, unsigned);
extern void HLU(blcluster*, mblock<float>**, mblock<float>**, mblock<float>**,
		double, unsigned);

extern void genLUprecond(blcluster*, mblock<double>**, double, unsigned,
			 blcluster*&, mblock<float>**&, mblock<float>**&, bool);
extern void genCholprecond(blcluster*, mblock<double>**, double, unsigned,
			   blcluster*&, mblock<float>**&, bool);
extern void genLUprecond(blcluster*, mblock<float>**, double, unsigned,
			 blcluster*&, mblock<float>**&, mblock<float>**&, bool);
extern void genCholprecond(blcluster*, mblock<float>**, double, unsigned,
			   blcluster*&, mblock<float>**&, bool);

extern void LTH_dense_solve(blcluster*, mblock<float>**, unsigned, float*, unsigned);
extern void LTHT_dense_solve(blcluster*, mblock<float>**, unsigned, float*,
			     unsigned);
extern void UTH_dense_solve(blcluster*, mblock<float>**, unsigned, float*, unsigned);
extern void UTHT_dense_solve(blcluster*, mblock<float>**, unsigned, float*,
			     unsigned);

extern void UTHT_H_solve(blcluster*, mblock<float>**, blcluster*,
			 mblock<float>**, double, unsigned);
extern void LTH_H_solve(blcluster*, mblock<float>**, blcluster*,
			mblock<float>**, mblock<float>**, double, unsigned);
extern void H_UTH_solve(blcluster*, mblock<float>**, blcluster*,
			mblock<float>**, mblock<float>**, double, unsigned);

extern void agglH(blcluster*, mblock<float>**, double, unsigned);

extern void agglHSym_stab(blcluster*, mblock<float>**, double, unsigned);

extern void fill_gaps(blcluster*, mblock<float>**, unsigned, unsigned&);

extern void convCCStoH(unsigned, double*, unsigned*, unsigned*, bool,
		       dof**, double, blcluster*, mblock<float>**&);
extern void convCRStoH(unsigned, double*, unsigned*, unsigned*, bool,
		       dof**, double, blcluster*, mblock<float>**&);
extern void convCCStoHSym(unsigned, double*, unsigned*, unsigned*, bool, dof**,
			  double, blcluster*, mblock<float>**&);
extern void convCRStoHSym(unsigned, double*, unsigned*, unsigned*, bool, dof**,
			  double, blcluster*, mblock<float>**&);

extern void expndHSym(blcluster*, mblock<float>**, blcluster*&, mblock<float>**);



//
//single precision complex
//

extern unsigned Hmax_rank(blcluster*, mblock<scomp>**);
extern unsigned HUTmax_rank(blcluster*, mblock<scomp>**);
extern unsigned HLTmax_rank(blcluster*, mblock<scomp>**);
extern mblock<scomp>** callocmbls(unsigned);
inline mblock<scomp>** callocmbls(blcluster* bl) { return callocmbls(bl->nleaves()); }

extern void freembls(blcluster*, mblock<scomp>**);
extern void multa_H_vec(scomp, blcluster*, mblock<scomp>**, scomp*, scomp*);
extern void multa_H_dense(scomp, blcluster*, mblock<scomp>**, unsigned,
                          scomp*, unsigned, scomp*, unsigned);
extern void multa_HT_vec(scomp, blcluster*, mblock<scomp>**, scomp*, scomp*);
extern void multa_HT_dense(scomp, blcluster*, mblock<scomp>**, unsigned,
                           scomp*, unsigned, scomp*, unsigned);
extern void multa_HSym_vec(scomp, blcluster*, mblock<scomp>**, scomp*, scomp*);
extern void multa_HSym_dense(scomp, blcluster*, mblock<scomp>**, unsigned,
                             scomp*, unsigned, scomp*, unsigned);
extern void add_H_lwr(blcluster*, mblock<scomp>**, double, unsigned, unsigned,
                      scomp*, unsigned, scomp*, unsigned);
extern void add_H_dense(blcluster*, mblock<scomp>**, scomp*, unsigned,
                        double, unsigned);
extern void add_HSym_lwr(blcluster*, mblock<scomp>**, double, unsigned, unsigned,
                         scomp*, unsigned, scomp*, unsigned);
extern void add_HSym_lwr_stab(blcluster*, mblock<scomp>**, double, unsigned, unsigned,
                              scomp*, unsigned, scomp*, unsigned);
extern void add_HSym_dense(blcluster*, mblock<scomp>**, scomp*, unsigned,
                           double, unsigned);
extern void multaHH(scomp, blcluster*, mblock<scomp>**, blcluster*, mblock<scomp>**,
                    blcluster*, mblock<scomp>**, double, unsigned);
extern void multa_H_H_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                             mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multaHTH(scomp, blcluster*, mblock<scomp>**, blcluster*, mblock<scomp>**,
                     blcluster*, mblock<scomp>**, double, unsigned);
extern void multa_HT_H_to_mbl(scomp, blcluster*, mblock<scomp>**,
                              blcluster*, mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multaHTH_to_HSym(scomp, blcluster*, mblock<scomp>**, blcluster*,
                             mblock<scomp>**, blcluster*, mblock<scomp>**, double, unsigned);
extern void multaHHT(scomp, blcluster*, mblock<scomp>**, blcluster*,
		     mblock<scomp>**, blcluster*, mblock<scomp>**,
		     double, unsigned);
extern void multa_H_HT_to_mbl(scomp, blcluster*, mblock<scomp>**,
                              blcluster*, mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multaHHT_to_HSym(scomp, blcluster*, mblock<scomp>**, blcluster*,
                             mblock<scomp>**, blcluster*, mblock<scomp>**,
			     double, unsigned);
extern void multaHSymH(scomp, blcluster*, mblock<scomp>**, blcluster*,
                       mblock<scomp>**, blcluster*, mblock<scomp>**, double, unsigned);
extern void multaHHSym(scomp, blcluster*, mblock<scomp>**, blcluster*,
                       mblock<scomp>**, blcluster*, mblock<scomp>**,
		       double, unsigned);
extern void multa_H_lwrT_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multa_HT_lwr_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multa_H_denseT_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                  mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multa_HT_dense_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                  mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multa_lwr_HT_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multa_lwrT_H_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multa_dense_HT_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                  mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void multa_denseT_H_to_mbl(scomp, blcluster*, mblock<scomp>**, blcluster*,
                                  mblock<scomp>**, mblock<scomp>*, double, unsigned);
extern void invertH(blcluster*, mblock<scomp>**, mblock<scomp>**, scomp, unsigned);
extern void invertHSym(blcluster*, mblock<scomp>**, mblock<scomp>**, scomp, unsigned);
extern void initH_0(blcluster*, mblock<scomp>**);
extern void initLTH_0(blcluster*, mblock<scomp>**);
extern void initUTH_0(blcluster*, mblock<scomp>**);
extern void initHSym_0(blcluster*, mblock<scomp>**);
extern void initH_Id(blcluster*, mblock<scomp>**);
extern void initHSym_Id(blcluster*, mblock<scomp>**);
extern unsigned long sizeH(blcluster*, mblock<scomp>**, char type='H');
extern void convHSymtofull(blcluster**, unsigned, mblock<scomp>**, scomp*, unsigned);
extern void psoutputHSym(std::ofstream&, blcluster*, unsigned, mblock<scomp>**, bool);
extern void psoutputLTH(std::ofstream&, blcluster*, unsigned, mblock<scomp>**, bool);
extern void psoutputUTH(std::ofstream&, blcluster*, unsigned, mblock<scomp>**, bool);
extern void psoutputH(std::ofstream&, blcluster*, unsigned, mblock<scomp>**, bool);
extern void copyH(blcluster*, mblock<scomp>**, mblock<scomp>**);
extern void copyH(blcluster*, mblock<dcomp>**, mblock<scomp>**);
extern scomp spctrlnrm_sym(unsigned, blcluster*, mblock<scomp>**, blcluster*,
                           mblock<scomp>**);
extern scomp spctrlnrm(unsigned, blcluster*, mblock<scomp>**, blcluster*, mblock<scomp>**);

extern void multa_part_vec(scomp, blcluster**, unsigned, mblock<scomp>**, scomp*,
                           scomp*);
extern void multa_partT_vec(scomp, blcluster**, unsigned, mblock<scomp>**, scomp*,
                            scomp*);
extern void psoutputH(std::ofstream&, blcluster**, unsigned, unsigned,
                      mblock<scomp>**, bool);
extern void psoutputHSym(std::ofstream&, blcluster**, unsigned, unsigned,
                         mblock<scomp>**, bool);
extern void multa_part_vec(scomp, blcluster**, unsigned,
                           mblock<scomp>**, scomp*, scomp*);
extern void multa_partT_vec(scomp, blcluster**, unsigned,
                            mblock<scomp>**, scomp*, scomp*);
extern void multa_sympart_vec(scomp, blcluster**, unsigned, mblock<scomp>**,
                              scomp*, scomp*);
extern void multa_LTH_vec(scomp, blcluster*, mblock<scomp>**, scomp*, scomp*);
extern void multa_LTHT_vec(scomp, blcluster*, mblock<scomp>**, scomp*, scomp*);
extern void multa_UTH_vec(scomp, blcluster*, mblock<scomp>**, scomp*, scomp*);
extern void multa_UTHT_vec(scomp, blcluster*, mblock<scomp>**, scomp*, scomp*);

extern void HCholesky(blcluster* const, mblock<scomp>** const, double, unsigned);
extern void HLU(blcluster*, mblock<scomp>**, mblock<scomp>**, mblock<scomp>**, double, unsigned);

extern void genLUprecond(blcluster*, mblock<dcomp>**, double, unsigned,
                         blcluster*&, mblock<scomp>**&, mblock<scomp>**&, bool);
extern void genCholprecond(blcluster*, mblock<scomp>**, scomp, unsigned,
                           blcluster*&, mblock<scomp>**&, bool);

extern void LTH_dense_solve(blcluster*, mblock<scomp>**, unsigned, scomp*,
			    unsigned);
extern void LTHT_dense_solve(blcluster*, mblock<scomp>**, unsigned, scomp*,
                             unsigned);
extern void UTH_dense_solve(blcluster*, mblock<scomp>**, unsigned, scomp*,
			    unsigned);
extern void UTHT_dense_solve(blcluster*, mblock<scomp>**, unsigned, scomp*,
                             unsigned);

extern void UTHT_H_solve(blcluster*, mblock<scomp>**, blcluster*,
			 mblock<scomp>**, double, unsigned);
extern void LTH_H_solve(blcluster*, mblock<scomp>**, blcluster*,
			mblock<scomp>**, mblock<scomp>**, double, unsigned);
extern void H_UTH_solve(blcluster*, mblock<scomp>**, blcluster*,
			mblock<scomp>**, mblock<scomp>**, double, unsigned);

extern void agglH(blcluster*, mblock<scomp>**, double, unsigned);

extern void agglHSym_stab(blcluster*, mblock<scomp>**, double, unsigned);

extern void fill_gaps(blcluster*, mblock<scomp>**, unsigned, unsigned&);

extern void convCCStoH(unsigned, dcomp*, unsigned*, unsigned*, bool,
                       dof**, double, blcluster*, mblock<scomp>**&);
extern void convCRStoH(unsigned, dcomp*, unsigned*, unsigned*, bool,
                       dof**, double, blcluster*, mblock<scomp>**&);
extern void convCCStoHSym(unsigned, dcomp*, unsigned*, unsigned*, bool, dof**,
                          scomp, blcluster*, mblock<scomp>**&);
extern void convCRStoHSym(unsigned, dcomp*, unsigned*, unsigned*, bool, dof**,
                          scomp, blcluster*, mblock<scomp>**&);

extern void expndHSym(blcluster*, mblock<scomp>**, blcluster*&, mblock<scomp>**);


//
//double precision complex
//

extern unsigned Hmax_rank(blcluster*, mblock<dcomp>**);
extern unsigned HUTmax_rank(blcluster*, mblock<dcomp>**);
extern unsigned HLTmax_rank(blcluster*, mblock<dcomp>**);
extern mblock<dcomp>** zallocmbls(unsigned);
inline mblock<dcomp>** zallocmbls(blcluster* bl) { return zallocmbls(bl->nleaves()); }

extern void freembls(blcluster*, mblock<dcomp>**);
extern void multa_H_vec(dcomp, blcluster*, mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_H_dense(dcomp, blcluster*, mblock<dcomp>**, unsigned,
                          dcomp*, unsigned, dcomp*, unsigned);
extern void multa_HT_vec(dcomp, blcluster*, mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_HT_dense(dcomp, blcluster*, mblock<dcomp>**, unsigned,
                           dcomp*, unsigned, dcomp*, unsigned);
extern void multa_HSym_vec(dcomp, blcluster*, mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_HSym_dense(dcomp, blcluster*, mblock<dcomp>**, unsigned,
                             dcomp*, unsigned, dcomp*, unsigned);
extern void add_H_lwr(blcluster*, mblock<dcomp>**, double, unsigned, unsigned,
                      dcomp*, unsigned, dcomp*, unsigned);
extern void add_H_dense(blcluster*, mblock<dcomp>**, dcomp*, unsigned,
                        double, unsigned);
extern void add_HSym_lwr(blcluster*, mblock<dcomp>**, double, unsigned, unsigned,
                         dcomp*, unsigned, dcomp*, unsigned);
extern void add_HSym_lwr_stab(blcluster*, mblock<dcomp>**, double, unsigned, unsigned,
                              dcomp*, unsigned, dcomp*, unsigned);
extern void add_HSym_dense(blcluster*, mblock<dcomp>**, dcomp*, unsigned,
                           double, unsigned);
extern void multaHH(dcomp, blcluster*, mblock<dcomp>**, blcluster*, mblock<dcomp>**,
                    blcluster*, mblock<dcomp>**, double, unsigned);
extern void multa_H_H_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                             mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multaHTH(dcomp, blcluster*, mblock<dcomp>**, blcluster*, mblock<dcomp>**,
                     blcluster*, mblock<dcomp>**, double, unsigned);
extern void multa_HT_H_to_mbl(dcomp, blcluster*, mblock<dcomp>**,
                              blcluster*, mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multaHTH_to_HSym(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                             mblock<dcomp>**, blcluster*, mblock<dcomp>**, double, unsigned);
extern void multaHHT(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
		     mblock<dcomp>**, blcluster*, mblock<dcomp>**,
		     double, unsigned);
extern void multa_H_HT_to_mbl(dcomp, blcluster*, mblock<dcomp>**,
                              blcluster*, mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multaHHT_to_HSym(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                             mblock<dcomp>**, blcluster*, mblock<dcomp>**,
			     double, unsigned);
extern void multaHSymH(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                       mblock<dcomp>**, blcluster*, mblock<dcomp>**, double, unsigned);
extern void multaHHSym(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                       mblock<dcomp>**, blcluster*, mblock<dcomp>**,
		       double, unsigned);
extern void multa_H_lwrT_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multa_HT_lwr_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multa_H_denseT_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                  mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multa_HT_dense_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                  mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multa_lwr_HT_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multa_lwrT_H_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multa_dense_HT_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                  mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void multa_denseT_H_to_mbl(dcomp, blcluster*, mblock<dcomp>**, blcluster*,
                                  mblock<dcomp>**, mblock<dcomp>*, double, unsigned);
extern void invertH(blcluster*, mblock<dcomp>**, mblock<dcomp>**, dcomp, unsigned);
extern void invertHSym(blcluster*, mblock<dcomp>**, mblock<dcomp>**, dcomp, unsigned);
extern void initH_0(blcluster*, mblock<dcomp>**);
extern void initLTH_0(blcluster*, mblock<dcomp>**);
extern void initUTH_0(blcluster*, mblock<dcomp>**);
extern void initHSym_0(blcluster*, mblock<dcomp>**);
extern void initH_Id(blcluster*, mblock<dcomp>**);
extern void initHSym_Id(blcluster*, mblock<dcomp>**);
extern unsigned long sizeH(blcluster*, mblock<dcomp>**, char type='H');
extern void convHSymtofull(blcluster**, unsigned, mblock<dcomp>**, dcomp*, unsigned);
extern void psoutputHSym(std::ofstream&, blcluster*, unsigned, mblock<dcomp>**, bool);
extern void psoutputLTH(std::ofstream&, blcluster*, unsigned, mblock<dcomp>**, bool);
extern void psoutputUTH(std::ofstream&, blcluster*, unsigned, mblock<dcomp>**, bool);
extern void psoutputH(std::ofstream&, blcluster*, unsigned, mblock<dcomp>**, bool);
extern void copyH(blcluster*, mblock<dcomp>**, mblock<dcomp>**);
extern dcomp spctrlnrm_sym(unsigned, blcluster*, mblock<dcomp>**, blcluster*,
                           mblock<dcomp>**);
extern dcomp spctrlnrm(unsigned, blcluster*, mblock<dcomp>**, blcluster*, mblock<dcomp>**);

extern void multa_part_vec(dcomp, blcluster**, unsigned, mblock<dcomp>**, dcomp*,
                           dcomp*);
extern void multa_partT_vec(dcomp, blcluster**, unsigned, mblock<dcomp>**, dcomp*,
                            dcomp*);
extern void psoutputH(std::ofstream&, blcluster**, unsigned, unsigned,
                      mblock<dcomp>**, bool);
extern void psoutputHSym(std::ofstream&, blcluster**, unsigned, unsigned,
                         mblock<dcomp>**, bool);
extern void multa_part_vec(dcomp, blcluster**, unsigned,
                           mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_partT_vec(dcomp, blcluster**, unsigned,
                            mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_sympart_vec(dcomp, blcluster**, unsigned, mblock<dcomp>**,
                              dcomp*, dcomp*);
extern void multa_LTH_vec(dcomp, blcluster*, mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_LTHT_vec(dcomp, blcluster*, mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_UTH_vec(dcomp, blcluster*, mblock<dcomp>**, dcomp*, dcomp*);
extern void multa_UTHT_vec(dcomp, blcluster*, mblock<dcomp>**, dcomp*, dcomp*);

extern void HCholesky(blcluster* const, mblock<dcomp>** const, double, unsigned);
extern void HLU(blcluster*, mblock<dcomp>**, mblock<dcomp>**, mblock<dcomp>**, double, unsigned);

extern void genLUprecond(blcluster*, mblock<dcomp>**, double, unsigned,
                         blcluster*&, mblock<dcomp>**&, mblock<dcomp>**&, bool);
extern void genCholprecond(blcluster*, mblock<dcomp>**, dcomp, unsigned,
                           blcluster*&, mblock<dcomp>**&, bool);

extern void LTH_dense_solve(blcluster*, mblock<dcomp>**, unsigned, dcomp*,
			    unsigned);
extern void LTHT_dense_solve(blcluster*, mblock<dcomp>**, unsigned, dcomp*,
                             unsigned);
extern void UTH_dense_solve(blcluster*, mblock<dcomp>**, unsigned, dcomp*,
			    unsigned);
extern void UTHT_dense_solve(blcluster*, mblock<dcomp>**, unsigned, dcomp*,
                             unsigned);

extern void UTHT_H_solve(blcluster*, mblock<dcomp>**, blcluster*,
			 mblock<dcomp>**, double, unsigned);
extern void LTH_H_solve(blcluster*, mblock<dcomp>**, blcluster*,
			mblock<dcomp>**, mblock<dcomp>**, double, unsigned);
extern void H_UTH_solve(blcluster*, mblock<dcomp>**, blcluster*,
			mblock<dcomp>**, mblock<dcomp>**, double, unsigned);

extern void agglH(blcluster*, mblock<dcomp>**, double, unsigned);

extern void agglHSym_stab(blcluster*, mblock<dcomp>**, double, unsigned);

extern void fill_gaps(blcluster*, mblock<dcomp>**, unsigned, unsigned&);

extern void convCCStoH(unsigned, dcomp*, unsigned*, unsigned*, bool,
                       dof**, double, blcluster*, mblock<dcomp>**&);
extern void convCRStoH(unsigned, dcomp*, unsigned*, unsigned*, bool,
                       dof**, double, blcluster*, mblock<dcomp>**&);
extern void convCCStoHSym(unsigned, dcomp*, unsigned*, unsigned*, bool, dof**,
                          dcomp, blcluster*, mblock<dcomp>**&);
extern void convCRStoHSym(unsigned, dcomp*, unsigned*, unsigned*, bool, dof**,
                          dcomp, blcluster*, mblock<dcomp>**&);

extern void expndHSym(blcluster*, mblock<dcomp>**, blcluster*&, mblock<dcomp>**);


// solve L x = b for x, forward substitution, b is destroyed
template<class T>
void LTH_vec_solve(blcluster* blL, mblock<T>** L, T* b)
{ LTH_dense_solve(blL, L, 1, b, blL->n1); }

// solve L^T x = b for x, forward substitution, b is destroyed
template<class T>
void LTHT_vec_solve(blcluster* blL, mblock<T>** L, T* b)
{ LTHT_dense_solve(blL, L, 1, b, blL->n1); }

// solve U x = b for x, forward substitution, b is destroyed
template<class T>
void UTH_vec_solve(blcluster* blU, mblock<T>** U, T* b)
{ UTH_dense_solve(blU, U, 1, b, blU->n1); }

// solve U^T x = b for x, forward substitution, b is destroyed
template<class T>
void UTHT_vec_solve(blcluster* blU, mblock<T>** U, T* b)
{ UTHT_dense_solve(blU, U, 1, b, blU->n2); }

// solve U^T U x = b for x and store x in b
template<class T>
inline void HCholesky_solve(blcluster* bl, mblock<T>** U, T* b)
{
  UTHT_vec_solve(bl, U, b);  // Forward substitution
  UTH_vec_solve(bl, U, b);  // Backward substitution
}

// solve L U x = b for x and store x in b
template<class T>
void HLU_solve(blcluster* bl, mblock<T>** L, mblock<T>** U, T* b)
{ 
  LTH_vec_solve(bl, L, b);    // Forward substitution
  UTH_vec_solve(bl, U, b);    // Backward substitution
}

// solve (L U)^T x = b for x and store x in b
template<class T>
void HLUT_solve(blcluster* bl, mblock<T>** L, mblock<T>** U, T* b)
{
  UTHT_vec_solve(bl, U, b);    // Backward substitution
  LTHT_vec_solve(bl, L, b);    // Forward substitution
}

#endif
