#ifndef BASMOD
#define BASMOD

#include <iostream>
#include <string>
#include <stdlib.h>
#include <cmath>

// fuer Maschinen-Genauigkeit
//#include<limits>
// numeric_limits<double>::min() liefert kleinsten positiven Zahl doppelter
//                               Genauigkeit

extern "C" double cputime(const double);
extern "C" double realtime(const double);
extern void progressbar(std::ostream&, char*,
			unsigned, unsigned, unsigned, bool);

//#define PRINT(X) std::cout << #X << " = " << X << std::endl;

inline double inMB(const double n)
{ return n/(1024.0*1024.0); }


template<class T> T max(T x, T y)
{
   return (x > y) ? x : y;
}

template<class T> T min(T x, T y)
{
   return (x < y) ? x : y;
}

inline unsigned pow2(unsigned k)
{
   return (1 << k);
}


template <class T> std::string to_str(const char *style, T n)
{                                                  
  std::string tmp;
    
  if (style == NULL) return tmp;
  
  char buffer[256];
    
  snprintf(buffer, sizeof(buffer), style, n);
  tmp = buffer;
    
  return tmp;
}

#endif   // BASMOD
