#ifndef SPARSE_H
#define SPARSE_H
#include "complex.h"
struct litem {
  unsigned i;             // the row, resp. the column
  double d;               // the value
  litem* next;            // the next item in the list
  litem(unsigned idx, double val, litem *succ=0) :
    i(idx), d(val), next(succ) { }
};

extern void add_item(litem*& list, unsigned i, double d);
extern unsigned len_list(litem* p);
extern void pack_list(litem* p, double*& pA, unsigned*& piA);

void amuxCRS(const unsigned, const double, double*, double*, double*,
	     unsigned*, unsigned*);
void atmuxCRS(const unsigned, const double, double*, double*, double*,
	      unsigned*, unsigned*);
void amuxCRS(const unsigned n, const dcomp d, dcomp* x, dcomp* y,
			 dcomp* A, unsigned* jA, unsigned* iA);
void atmuxCRS(const unsigned n, const dcomp d, dcomp* x, dcomp* y,
			 dcomp* A, unsigned* jA, unsigned* iA);

extern "C" {
  void ilutp_(unsigned*, double*, unsigned*, unsigned*, unsigned*, double*,
	      double*, unsigned*, double*, unsigned*, unsigned*, unsigned*,
	      double*, unsigned*, unsigned*, int*);
  void lusol_(unsigned*, double*, double*, double*, unsigned*, unsigned*);
}

extern unsigned BiCGStabILU(unsigned, double*, unsigned*, unsigned*, double*,
			    double*, double&, unsigned&, double*, unsigned*,
			    unsigned*);
extern unsigned BiCGStabILU(unsigned, float*, unsigned*, unsigned*, float*,
			    float*, float&, unsigned&, float*, unsigned*,
			    unsigned*);
#endif
