#ifndef CurlFunctions_h__
#define CurlFunctions_h__



namespace femlib
{
	//////////////////////////////////////////////////////////////////////////
	// Curl
	//////////////////////////////////////////////////////////////////////////
	//************************************
	// Method:    get_curl_edge
	// FullName:  femlib::get_curl_edge
	// Access:    public 
	// Returns:   _EXTERN_ double			jacobi detimant at (xi,eta,zeta)
	// Description: Get the curl of an edge function
	// Parameter: double xi					local coodinate 1
	// Parameter: double eta				local coodinate 1
	// Parameter: double zeta				local coodinate 1
	// Parameter: double * GEOM				std. GEOM Array
	// Parameter: unsigned * node_labelsArg	array with 10 nodeslabels
	// Parameter: Vec3 * return_curls			
	//************************************
	_EXTERN_ double get_curl_edge(double xi, double eta, double zeta, double* GEOM, unsigned* node_labelsArg,Vec3* return_curls);


	//************************************
	// Method:    get_curl_atQP
	// FullName:  femlib::get_curl_atQP
	// Access:    public 
	// Returns:   _EXTERN_ void
	// Description: Evaluates the curl of an edge function at the 4 QP of the QTET4 Routine
	// Parameter: double * GEOM				std. GEOM
	// Parameter: unsigned * node_labelsArg array with 10 nodeslabels
	// Parameter: Vec3 * resulte		size: 6 * 4 stored as 
	//				for(edge_i=0;edge_i<6;edge_i++)
	//				{		results[ge(edge_i,qp_i,6)]=curls_local[edge_i];}
	// Parameter: double * dets			size: 4  jacobi det at the 4 QP
	//************************************
	_EXTERN_ void get_curl_atQP(double* GEOM, unsigned* node_labelsArg,Vec3* results, double* dets);
} // end femlib

#endif // CurlFunctions_h__