#ifndef Fortran_h
#define Fortran_h Fortran_h
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
//#include "config.h"
#include "global_constants.h"
#include "defines.h"
#include "vector3d.h"

//#include "Matrix.h"
//#ifdef LINUX
//#undef _EXTERN_
//#define _EXTERN_ inline 
//#endif
using namespace std;
extern "C" {

	 //Felib 4.0
	 /*void  matinv( double*, const int*, const int*, double*, const int*, 
				  const int*, const int*, const double*, const int* ); 	*/
	void  matinv( double*, const int*, const int*, double*, const int*, 
				  const int*, const int*, const double*, const int* ); 	
	 void matmul( double*, const int*, const int*, double*, const int*, const int*, 
				 double*, const int*, const int*, const int*, const int*, const int*, const int* ); 
	 void tet10( double*, const int*, double*, const int*, const int*, const double*, const double*, const double*, int* ); 
	 void qtet4( double*, const int*, double*, const int*, const int*, const int*, const int* ); 
	 void qtri4( double*, const int*, double*, const int*, const int*, const int*, const int* ); 
	 void qtri7( double*, const int*, double*, const int*, const int*, const int*, const int* ); 
	 void trim6( double*, const int*, double*, const int*, const int*, const double*, const double*, const int* ); 
	 void matvec(double*, const int*, const int*, double*,const int*,const int*,const int*,double*, const int*, const int*);
	 void tet4( double*, const int*, double*, const int*, const int*, const double*, const double*, const double*, int* );
	 //Sparse Matrix with dense multiplication 
	 //void mkl_dcsrmm(char *transa, int *m, int *n, int *k, double *alpha, char *matdescra, 
		// double  *val, int *indx,  int *pntrb, int *pntre, double *b, int *ldb, double *beta, 
		// double *c, int *ldc);

	 
	 //Spare Blas Routines	 //wihtout Interface Functions
	 /*void dgemv ( const int* TRANS,const int *M,const int *N,
     			 const double *ALPHA,const double* A,const int *LDA,const double* X,
				const int *INCX,const double *BETA,double* Y,const int *INCY ); */
	 void ddoti( const int* NZ, const double* X, 
					const int* INDX, const double* Y,  double* result ); 
	 /*void amux( const unsigned* n , const double* x, double* y, const double* a,
				const unsigned* ja, const unsigned* ia ); 
	 void atmux( const unsigned* n , const double* x, double* y, const double* a,	  
				const unsigned* ja, const unsigned* ia ); */
	 //y = d*A*x, d is scalar
	 void amuxd( const int* n , const double* d ,const double* x, double* y, 
				const double* a, const int* ja, const int* ia ); 
	 //y = ( d*A^T )*x, d is scalar
	 void atmuxd( const int* n , const double* d, const double* x, double* y, 
				 const double* a, const int* ja, const int* ia ); 
	 void lusol( const unsigned*n, const double*y, double*x, const double*alu, 
				const int*jlu, const int*ju ); 
	 void ilutp( const unsigned*n, const double*a,const unsigned*ja,const unsigned*ia,
				const int*lfil,	const double*droptol,const double*permtol,const int*mbloc,
				double*alu, int*jlu, int*ju, int*iwk, double*w, int*jw,int*iperm, int*ierr ); 
	 void qsplit(  double*a,int*ind,int*n,int*ncut ); 

}
	//! i row
	//! j col
	//! i no. of rows in matrix ( Leading Dimension ) 
	//! Matrix 1 2 3  will be saved as 1 4 2 5 3 6
	//!		   4 5 6
	//!  check if i >= 0 and j >= 0 
  _EXTERN_ unsigned ge( unsigned i,unsigned j,unsigned n );


namespace felib
{

	  //Invert Matrix A and stores the result in B, A is mA x nA ( mA  =  nA )
	  //restricted to full-rank matrices and matrices 3x3 or 2x2 by felib
	  // returns the test value
	 _EXTERN_ void inv( double* A, int mA, double* &B,  double &det, int test );
	//Invert Matrix A and stores the result in B, A is mA x nA ( mA  =  nA )
	//restricted to full-rank matrices and matrices 3x3 or 2x2 by felib
	_EXTERN_ void inv( double* A, int mA, double* &B,  double &det );
	 
	//!Invert Full-Interface ( all options )
    //!A is mAxnA
    //!B is mBxnB
    //!N is order of A
	_EXTERN_ void inv( double* A, int mA, int nA, double* &B, int mB, int nB, int N,  double &det, int &test );
	  //!_EXTERN_ void tet10( double 
	  //!A*B = C A is mA x nA, B is nA x nB, C is mAxnB
	  _EXTERN_ void mul( double* A, int mA, int nA, double* B, int nB, double* &C );
	  //Full Interface
	  _EXTERN_ void mul( double* A, int mA, int nA, double* B, int mB,int nB, 
		  double* &C, int mC, int nC, int L, int M, int N, int test );

	  //!Matrix-Vector Multiplication from FELIB
	  //!A is mxn
	  //!x is nx1
	  //!C is mx1
	  _EXTERN_ void mat_vec(double* A,int m, int n,double* x,double* C);
	  
	  //!Get Shapefunctions for TET10 Element,
	  //!Shapefunc[ 10 ]
	  //!LDER[ 3 ][ 10 ]
	  //!Xi, Eta, Zeta local coordinates
	  _EXTERN_ void tet_10( double* &Shapefunc, double* &LDER, double XI, double ETA, double ZETA );
	  //Full Interface TET_10
	  _EXTERN_ void tet_10( double* Shapefunc, int IFUN_L, double* &LDER, int ILDER_L, int JLDER_L, double XI, double ETA, double ZETA, int &test );

	  //!Get Shapefunctions for TET4 Element,
	  //!Shapefunc[ 4 ]
	  //!LDER[ 3 ][ 4 ]
	  //!Xi, Eta, Zeta local coordinates
	  _EXTERN_ void tet_4( double* &Shapefunc, double* &LDER, double XI, double ETA, double ZETA );
	  //!Get Shapefunctions for TRIA6 Element,
	  //!Shapefunc[ 6 ]
	  //!LDER[ 2 ][ 6 ]
	  //!Xi, Eta local coordinates
	  _EXTERN_ void trim_6( double* Shapefunc, double* &LDER,  double Xi, double Eta );
	  //Full Interface trim_6
	  _EXTERN_ void trim_6( double* Shapefunc, int IFUN_L, double* LDER, int ILDER_L, int JLDER_L,  double Xi, double Eta, int &test );	
	  //!Four Pont Quadrature Rule for TETs 
	  //! WGHT[ 4 ]
	  //! ABSS[ 3 ][ 4 ] 
	  // returns the WEIGHTs and the absciss-values  of the quad-points
	  _EXTERN_ void qtet_4( double* WGHT, double* ABSS );
	  //Full Interface qtet4
	  _EXTERN_ void qtet_4( double* WGHT,int NIWGHT, double* ABSS, int NIABSS, int NJABSS, int NQP,int &test );

	  //!Four Point Quadrature Rule for TRIAs
	  //! WGHT[ 4 ]
	  //! ABSS[ 2 ][ 4 ]
	  // returns the WEIGHTs and the absciss-values  of the quad-points
	  _EXTERN_ void qtri_4( double* &WGHT, double* &ABSS );
	  //!Full interface qtri4
	  _EXTERN_ void qtri_4( double* WGHT,int IWGHT_A, double* ABSS, int IABSS_A, int JABSS_A, int NQP,int &test );

	  //!Seven Point Quadrature Rule for TRIAs
	  //! WGHT[ 7 ]
	  //! ABSS[ 2 ][ 7 ]
  	  // returns the WEIGHTs and the absciss-values  of the quad-points
	  _EXTERN_ void qtri_7( double* &WGHT,  double* &ABSS );

	  //Full interface qtri7
	  _EXTERN_ void qtri_7( double* WGHT,int IWGHT_A, double* ABSS, int IABSS_A, int JABSS_A, int NQP,int &test );
	  //! Init a array of the length length with 0.0
	  _EXTERN_ void zero( double* A, unsigned length );
	  //! Init a array of the length length with 0
	  _EXTERN_ void zero( int* A, unsigned length );



}//end namespace felib
#endif

