#ifndef DEFINES_H 
#define DEFINES_H
#include "vector3d.h"
/* ========================================================================== */
/*                                                                            */
/*    defines.h                                                              */
/*    define some global function like PRINT and GE             */
/*              */
/*                                                                          */
/*                                                                            */
/* ========================================================================== */


using namespace std;
using namespace vector3d;
///Platform specific inline defintions
#ifdef WIN32
	#define _INLINE_ inline
	#define _EXTERN_ extern
#endif

#ifdef LINUX
	#define _INLINE_ 
	#define _EXTERN_ 
#endif

#define MIN(a,b) ((a) <= (b) ? (a) : (b))
#define MAX(a,b) ((a) >= (b) ? (a) : (b))
#define LTR(i,j,n) (((2*n-j-1)*j)/2+i)
#define UTR(i,j) ((j*(j+1))/2+i)
#define ge(i,j,n) (((i)+((j)*(n))))
#define SIGN(a) ((a) >= 0 ? 1.0 : -1.0)
#define PRINT( X )   cout<< #X << " =  " << X << flush << endl

//!TET10
#define IFUN 10		///Shapefunctions Tet10 length
#define ILDER 3		///Local Derivates Tet rows
#define JLDER 10	///Local Derivates Tet cols
#define IGEOM 10
#define JGEOM 3
#define NODEL10 10 	///Number of Nodes per Tet
#define IGDER 3		///Global Derivates Tet rows
#define JGDER 10	///Global Derivates Tet cols

//!TRIA6
#define SIFUN 6		///Shapefunctions Tria6	length
#define SILDER 2	///Local Derivates Tria rows
#define SJLDER 6	///Local Derivates Tria cols
#define SIJAC 2 	///Jacobian Tria rows
#define SJJAC 2 	///Jacobian Tria cols
#define SIGEOM 6 	///Geom Array ((x,y)-node coordinates) Tria rows
#define SJGEOM 2 	///Geom Array ((x,y)-node coordinates) Tria cols

//!TET4
#define IFUN4 4
#define ILDER4 3
#define JLDER4 4
#define IGDER4 3
#define JGDER4 4
#define IGEOM4 4
#define JGEOM4 3

//!TET4 and TET10
#define IJAC 3
#define JJAC 3
#define IJACIN 3
#define JJACIN 3

//!INTEGRATION FELIB TET (4pt Quad rule)
#define M_ABSS 3	//4-Point Tet-Quadrature Positions rows
#define N_ABSS 4	//4-Point Tet-Quadrature Positions cols
#define M_WGHT 4	///4-Point Tet-Quadrature Weights length
#define IABSS 3
#define IABSS 3		///4-Point Tet-Quadrature Positions rows
#define JABSS 4		///4-Point Tet-Quadrature Positions cols
#define SIABSS 2	///7-Point Tria-Quad. rows
#define SJABSS 7	///7-Point Tria-Quad. cols

#define SIGDER 2	///Global Derivates Tria rows
#define SJGDER 6	///Global Derivates Tria cols
#define IWGHT 4 	///4-Point Tet-Quadrature Weights length
#define SIWGHT 7 	///7-Point Tria-Quadrature Weights length
//Other 
#define DIMEN 3 	///Dimension of Tets.


#endif
